<?php
namespace Claromentis\People\Filter;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] ?: array()) + array("_680cc2b8220" . "e94c8c32b8bc" . "7c65519b4" => base64_decode("aXNfaW5" . "0"), "_f11369824" . "f533e8206f" . "9ccc0c9aab" . "3a0" => base64_decode("bGltaXQ" . "="), "_1f50e30be8c2fefa6881834" . "e71d504a2" => base64_decode("b2Z" . "mc2" . "V0"));
use Claromentis\Core\Security\SecurityContext;
use Psr\Http\Message\ServerRequestInterface;







abstract class AbstractPeopleFilter
{
    
    
    public $context;
    const DEFAULT_LIMIT = 20;
    const MAX_LIMIT = 200;
    
    
    protected $limit = self::DEFAULT_LIMIT;
    
    
    protected $offset = 0;
    public function __construct(SecurityContext $context)
    {
        $this->context = $context;
    }
    public function IsPaginationSet()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_680cc2b8220e94" . "c8c32b8bc7c6551" . "9b4"]($this->limit) && $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_680cc2b8220e" . "94c8c32b8bc7c" . "65519b4"]($this->offset);
    }
    
    
    
    
    
    
    
    
    
    
    public function GetPublicDefaults() : array
    {
        return [$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f11369824" . "f533e8206f" . "9ccc0c9aab" . "3a0"] => $this->limit, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_1f50e30be8c2fefa6881834" . "e71d504a2"] => $this->offset];
    }
    
    
    
    
    
    
    
    
    public function SetPaginationAttributesFromRequest(ServerRequestInterface $request) : void
    {
        $this->SetOffset($request->getAttribute($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_1f50e30be8c2fe" . "fa6881834e71d50" . "4a2"], 0));
        $this->SetLimit($request->getAttribute($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_f11369824f533e" . "8206f9ccc0c9aab" . "3a0"], self::DEFAULT_LIMIT));
    }
    
    
    
    
    
    
    public function SetLimit(int $_f11369824f533e8206f9ccc0c9aab3a0) : void
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_680cc2b8220e" . "94c8c32b8bc7c" . "65519b4"]($_f11369824f533e8206f9ccc0c9aab3a0) || $_f11369824f533e8206f9ccc0c9aab3a0 <= 0) {
            return;
        }
        if ($_f11369824f533e8206f9ccc0c9aab3a0 > self::MAX_LIMIT) {
            $_f11369824f533e8206f9ccc0c9aab3a0 = self::MAX_LIMIT;
        }
        $this->limit = $_f11369824f533e8206f9ccc0c9aab3a0;
    }
    
    
    
    
    
    
    public function SetOffset(int $_1f50e30be8c2fefa6881834e71d504a2) : void
    {
        if (!$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_680cc2b8220e94" . "c8c32b8bc7c6551" . "9b4"]($_1f50e30be8c2fefa6881834e71d504a2) || $_1f50e30be8c2fefa6881834e71d504a2 < 0) {
            return;
        }
        $this->offset = $_1f50e30be8c2fefa6881834e71d504a2;
    }
    
    
    
    
    public function Limit() : int
    {
        return $this->limit;
    }
    
    
    
    
    public function Offset() : int
    {
        return $this->offset;
    }
}